CP.Cryptophotosettings = {

    MAIN_PANEL_ID: 'cryptophoto_main_panel',

    init: function() {
        var page = {
            title:"Change Current User's Password"
            ,params:{}
            ,submitURL: '/cgi-bin/cryptophotosettings.tcl'
            ,afterSubmit: CP.Cryptophotosettings.init
            ,panel: Ext.create( 'CP.WebUI4.DataFormPanel',{
                id: CP.Cryptophotosettings.MAIN_PANEL_ID, 
                items: CP.Cryptophotosettings.getPageItems(),
		height: Ext.get("config-tab-body").getBox().height + 50,
                listeners: {
                    render: CP.Cryptophotosettings.doLoad
                }
            })
        };
        CP.UI.updateDataPanel(page);
    },

    getPageItems: function() {
        var items = [{
                //Add section title to panel
                xtype: 'cp4_sectiontitle',
                titleText: 'CryptoPhoto Settings'
            },{
                xtype: 'cp4_panel',
		height: Ext.get("config-tab-body").getBox().height + 50,
                autoScroll: true,
                forceFit: true,
		layout: "fit",
                padding: '0 15 15',      
                defaults: {
                    xtype: 'cp4_panel'
                },
                items: [{
                    xtype: 'cp4_container',
                    flex: 1,       
                    html: '<style>.cp-tt>span#tooltiptxt{color:#fff}</style><div id="cp_widget" class="cp_widget" style="max-width:1000px">Loading...</div>'
                }]
            }];
	return items;
    },

    doLoad: function(panel) {
        panel.load({
	    url: '/cgi-bin/cryptophotosettings.tcl',
	    method: 'GET',
	    success: function(form, action) {
		var response = action.result;
		if (response.success == "false") {
		    Ext.get("cp_widget").update("Error: " + response.data.err + (typeof response.data.errIP != "undefined" ? " (" + response.data.errIP + ")" : ""));
                } else if (response.data.sid) {
		    var sid = response.data.sid;
		    var server = response.data.server;
		    var s = document.createElement('SCRIPT');
		    s.charset = 'UTF-8';
		    s.async = true;
		    s.src = server + "/api/token?sd=" + sid;
		    document.getElementsByTagName('body')[0].appendChild(s);
		}
	    },
	    failure: function(form, action) {
		console.log("failure: " + JSON.stringify(action.result))
	    }
        });
    }
}