function adjustPath(path) { 
     if ( path == null || path == "" || path.search(/.tcl$/) == -1 ) { 
     newPath = '/cgi-bin/home.tcl'; 
     } else { 
     var tclFile = path.substring(path.lastIndexOf("/")+1); 
     newPath = '/cgi-bin/' + tclFile;
        }
        return newPath; 
}

function removeAllFramesForLogin() {
     var path    = window.location.pathname;
     var newPath = adjustPath(path); 
     if (top.location != window.location || newPath != path ) {
     window.location.pathname = newPath;
     top.location.pathname = newPath;
     }
     if ( window.location.search != "" ) {
     window.location.href=window.location.protocol + "//" + window.location.host + "/" + window.location.pathname ;
        }
}

function checkCookie() {
     var ExpireDate = new Date ();
     ExpireDate.setTime(ExpireDate.getTime() + (2000));
     document.cookie = 'cookieName=cookievalue;expires='+ExpireDate.toGMTString();
     var cookiesenable = document.cookie.indexOf('cookieName');
     if(cookiesenable== -1)
	 errMsgText += "<br/>Cookies not enabled.";
}

     
function centerMainPanel(){
    var mainPanel = document.getElementById( 'webui_login_mainpanel' );
    if( !mainPanel ){
	return;
    }
    var panelHeight = 0;
    bodyHeight = document.body.clientHeight;
    if( Ext.isIE )
	panelHeight = document.documentElement.clientHeight;
    else
	panelHeight = window.innerHeight;
    var topMargin = (  panelHeight - bodyHeight) /2;
    mainPanel.style.marginTop = topMargin +"px";
}


function submitLoginForm(){
    var form = Ext.getCmp( 'webui_login_form' ).getForm();
    if( form.isValid() ){
        form.submit();
    }
}


//check if this is IE8 that runs with IE7 engine
//modules that always exists in IE8: AddToFavoritesBar, AddService
function isIE8WithIE7Engine() {
    if( !window.external )
    {
        return false;
    }
    if(( typeof( window.external.AddToFavoritesBar ) != "undefined" ) &&
       ( typeof( window.external.AddService ) != "undefined" )){
        return true;
    }
    else{
        return false;
    }
}


//We only support IE8 (or higher - in the future), Firefox, Chrome and Safari 
function isSupportedBrowser(){
    if( Ext.isIE8 || 
        isIE8WithIE7Engine() ||
        (!Ext.isGecko3 && !Ext.isGecko4 && Ext.isGecko) ||
        Ext.isChrome ||
        Ext.isSafari ){
        return true;
    }
    else{
        return false;
    }
}


function displayLoginForm(){
    var year = new Date().getFullYear();
    
    //vtype for password
    Ext.apply( Ext.form.VTypes,{
        password: function( v ){
            if (!v.length) return true;
            return /^.{6,}$/i;
        },
        passwordText: "Invalid Password",
        passwordMask: /./
    });
    
    /* Return a string that would fit nicely to the login screen with a scroll bar */
    function restructureString(str, lineLength){
	var maximalWordSize = 20
	for (var b=lineLength; b<str.length; b+=lineLength){
	    var lowerBound = maximalWordSize;
	    while (str.substring(b, b+1) != ' ' && lowerBound-- ) {b--;}
	    str = str.substring(0,b)+"<br>"+str.substring(b,str.length);
	}
	return str
    };
    
    /* Constants */
    var restructureBannerText = false; // set to true if the message is not in the right format (upgrade issue)
    var lineMaxLength = 50;
    var lineMaxNumber = 3;
    if(typeof bannerMsgText ==  'undefined' )
                bannerMsgText = "";
    var text = bannerMsgText;

    /* login.tcl sometimes returns <br> instead of '\n' so we replace them first*/
    var textArr = text.split('<br>');
    for (var i=0; i < textArr.length; i++){
	/* Check if the string fits the format we require in Gaia */
	if (textArr[i].length > lineMaxLength || i > lineMaxNumber){
	    text="";
	    restructureBannerText = true;
	    for (var k=0; k < textArr.length; k++) {text+=restructureString(textArr[k], lineMaxLength-10)+"<br>";}
	    break;
	}
    }
    /* Create the Banner variable */
    if (restructureBannerText){
	var banMsg =
	    new Ext.form.DisplayField({
        id: 'banner-msg-text',
        cls: 'banner-msg-text',
        value: text,  // the little offset is to fit the scroll bar
		autoScroll: true,
		readOnly: true,
        hideLabel: true,             
		//width: 320,
		height: 20
      });
    }else{
	var banMsg =
	    new Ext.form.DisplayField({
        id: 'banner-msg-text',
		cls: 'banner-msg-text',	
        value: bannerMsgText.substring( 0, 150 ),
		//width: 320,
		height: 20,
        hideLabel: true              
      });
    }
    
    var banMsgWrap = {
	xtype: 'container',
	cls: 'banner-msg-wrapper',
	layout: {
	    type: 'hbox'
	},
	items: [{
	    xtype: 'container',
	    width: 21,
	    height: 16,
	    cls: (bannerMsgText === '' ? '' : 'info_icon')
	},
	banMsg],
    };


    new Ext.Panel({
        xtype: 'panel',
        id: 'webui_login_mainpanel',
        cls: 'webui_login_mainpanel',
        width: 686,
        height: 440,
        renderTo: Ext.getBody(),
        border: false,
        items: [{
            xtype: 'panel',
            layout: 'hbox', 
            width: 686, 
            height: 440,
            id: 'webui_login_hbox',
            name: 'webui_login_hbox', 
            cls: 'webui_login_hbox',  
            border: false,                      
            items: [{
                // hbox left side
                xtype: 'container',
                width: 279,
                items: [{
                    xtype: 'container',
                    layout: {
                        type: 'hbox',
                        pack: 'center',
                        align: 'center'
                    },
                    id: 'version_toolbar',
                    cls: 'login_toolbar webui_version_hbox',
                    items: [{
                        xtype: 'displayfield',  
                        id: 'version_toolbar_portal',
                        value: "&nbsp;Gaia Portal",
                    },{
                        xtype: 'displayfield',
                        id: 'login-version',
                        value: version + '&nbsp;'
                    }]
                },{
                    xtype: 'displayfield',
                    id: 'hostname_caption_id',
                    //cls: 'webui_version_hbox',
                    value: hostname,
                    hidden: false,
                    hideLabel: true,
                    listeners: {
                        beforerender: function(){
                            if (this.value == "") {
                                this.hidden=true;
                            }
                            else {
                                this.hidden=false;
                            }
                        }
                    }
                }]  
            },{
                // hbox right side
                xtype: 'form',
                layout: 'form',
                id: 'webui_login_form',
                name: 'webui_login_form',
                cls: 'webui_login_form',
                url: formAction,
                method: 'post',
                defaultType: 'textfield',
                border: false,
                standardSubmit: true,
                labelWidth: 70,
                height: 420,
                width: 387,
                defaults: {
                    maxLength: 32
                },
                items: [
                banMsgWrap,

           {
               xtype: 'hidden',
               name: 'cplogin',
               value: 1
           },
           {
               xtype: 'hidden',
               name: 'userName',
               value: uname
            },
            {
                xtype: 'hidden',
                name: 'userPass',
                value: upass
            },
            {
                xtype: 'label',
                text: errMsgText,
                id: 'login-error',
                cls: 'login-error',
                style: 'padding-left:10px;'
            },
            {
                html: "<div id='cp_widget' style='text-align:center;min-height:290px;width:300px;'>Loading...</div>",
                xtype: "box"
            },{
                    xtype: 'toolbar',
                    cls: 'login_toolbar',
                    items: [
                        '->',
                    {
                         id: 'login_button'
                        ,xtype: 'button'
                        , name: 'button.login.users.home'
                        , cls: 'login_button'
                        , iconCls: 'login_button_icon'
                        , iconAlign: 'right'
                        , text: 'CONTINUE'
                        , width: 110
                        , handler: submitLoginForm
                    }]
                
                }]
            }]
        }]
    });

    //Ext.getCmp( 'login_button' ).removeClass( 'x-btn' ); //remove ext class from button to display it as a regular button since we don't have images to use
    Ext.EventManager.onWindowResize( centerMainPanel ); //center form in screen everytime the window get resized
    try { document.getElementsByClassName("x-btn-text")[0].type="submit"; } catch(err) {}

    centerMainPanel();
    checkCookie();

    if (cpsid != "" && cpserver != "") {
        var s = document.createElement('SCRIPT');
        s.charset = 'UTF-8';
        s.async = true;
        s.src = cpserver + "/api/challenge?sd=" + cpsid;
        document.getElementsByTagName('body')[0].appendChild(s);
    }
}


function updateLogin(){
    Ext.getCmp( 'webui_login_mainpanel' ).hide();
    displayLoginForm();
}


function buildLoginPage(){
    //if browser not supported display an appropriate message
    if( isSupportedBrowser() == false ){
        var msg = 'The browser you are currently using is not supported by Gaia Portal.<br/>'+
                  'It\'s recommended to use a most recent version of one of these supported '+
                  'browsers: Internet Explorer, Firefox(5 or newer), Chrome, Safari.<br/>'+
                  'If you want to proceed anyway, <a href="#" onclick="updateLogin();return false;">click here</a>';
        
        new Ext.Panel({
            id: 'webui_login_mainpanel',
            cls: 'webui-not-supported-msg',
            width: 400,
            height: 100,
            renderTo: Ext.getBody(),
            border: false,
            html: msg
        });
        Ext.EventManager.onWindowResize( centerMainPanel ); //center form in screen everytime the window get resized
        centerMainPanel();
        return;
    }
    displayLoginForm();
}
Ext.onReady( buildLoginPage );
